class Employee
emp = new Employee

class Employee
   constructor: (name) ->
      @name = name

class Employee
   constructor: (@name) ->

emp = new Employee "John"
console.log emp.name # output: John

class Employee
   constructor: (@name, @salary) ->
      @getSalary = -> salary
emp = new Employee "John", 30000
console.log emp.name # output: John
console.log emp.salary # output: 30000
console.log emp.getSalary() # output: 30000

class Employee
   @numEmployees: 0
   constructor: (@name) ->
      Employee.numEmployees++
   @getNumEmployees: -> Employee.numEmployees
emp = new Employee "John"
emp = new Employee "Jane"
console.log Employee.numEmployees # output: 2
console.log Employee.getNumEmployees() # output: 2

class Employee
   numEmployees: 0
   constructor: (@name) ->
      Employee.prototype.numEmployees++
   @getNumEmployees: -> Employee.prototype.numEmployees
emp1 = new Employee "John"
emp2 = new Employee "Jane"
console.log Employee.prototype.numEmployees # output: 2
console.log Employee.getNumEmployees() # output: 2

class PrivacyDemo
   x = 1
   foo = ->
     console.log "private method"

class Employee
   constructor: (@name) ->
      @getName = -> name
   
class Accountant extends Employee
   constructor: (name) ->
      super name
acct = new Accountant "John"
console.log acct.getName() # output: John

class Base
   constructor: ->
      @a = 1
class Derived extends Base
   constructor: ->
      super
      @b = 2
derived = new Derived
console.log "#{name}: #{value}" for name, value of derived
console.log ""
console.log "#{name}: #{value}" for own name, value of derived